﻿This mod takes the existing unused model of Ancient wisp, strips everything off it, and adds 4 new skills. a passive, 10 new animations, 8 skins, and way too many particle effects for me to count.

## Feedback (Please? I'll beg if needed)
- I am extremely open to any kind of feedback, question, suggestion, bug report, or really anything.
- I have a simple discord set up to help keep bug reports and feedback organized for all my mods, feel free to join and all that.
- https://discord.gg/TgaDGNh
- You can also DM me on discord if that is easier. (@Rein#7551)

## Showcase video

[![Showcase video](https://img.youtube.com/vi/b3nuIeHQwoE/0.jpg)](https://www.youtube.com/watch?v=b3nuIeHQwoE)


### Install
- Delete old versions. (You never know)
- Unzip the plugin zip.
- Copy all files to the plugins folder in Bepinex(in your game install directory)
- Bonus points if you create a separate folder inside the plugins folder for every mod

### Uninstall
- Delete the files that come with the mod from the plugins folder

## New this update
- Under the hood tweaks
- Now works with dedicated servers

## Testimonials
- "Thats kinda hot" -Violet Chaolan

## Character Information

### Lore
- Yeah... Maybe some day.

### Base Stats
- 100 ( +30 ) health.
- 30 ( +9 ) shield.
- 12 (+2.4) damage.
- 0.6 ( + 0.12 ) health regen.
- All other stats are standard.

### Skills
- Descriptions for the skills and passive can be found in game. Feel free to ask me if you have any questions.

### Playstyle
- Rogue Wisp is a short ranged, immobile, high-damage caster.
- They have an additional resource to manage called Flame Charge which is gained from primary, and from being within range of Utility while enemies are burning.
- Flame Charge increases the potency of abilities, but falls off over time if it is over a certain threshold.
- Flame Charge is visible as a UI element next to the crosshair. As it increases the bar goes from black (0) to white to red to green to blue to orange to teal to purple and then repeats (although it is exceptionally rare to increase it that high)
- All skills except primary consume Flame Charge on use.

### General tips for playing them
- You want to have your utility down as often as possible, and you also want to be inside with as many enemies as possible.
- Doing this will dramatically increase your damage output, with obvious risks associated.
- Remember that there is no upper limit to your Flame Charge, but the rate of decrease increases with the value. At extremely high charge values your damage can be multiplied by 30, or even more.

## Future plans
- Much of the balancing is still in progress to some degree. Feedback is incredibly helpful here.
- I am always looking to improve performance and fix bugs, so please inform me if you find anything.

### Fairly soon (A few weeks or so, life permitting)
- Rewriting the way primary restores charge and deals damage
- Configuration options for visual effects (Some people have mentioned they are a bit too bright, figured a setting would solve this issue)

### Fairly soon (within two to three weeks)
- Cleaning up animations
- Streamlining Primary and Secondary mechanics.

### Later (a few months maybe? idk)
- Skill variants
- Custom unlocks (With a new stage and custom boss, maybe a few items as well)

## Changelog

### 1.3.2
- Under the hood tweaks
- Now works with dedicated servers

### 1.3.1
- Compatibility with Hidden Realms update.
- Skill icons (Huge thanks to Tera, who made all 4 of them)
- Improved compatibility with mods that hook RecalculateStats

### 1.3.0
- Reworked primary. Now has better range, deals more damage, and pierces enemies, and restores charge per enemy hit.
- Greatly improved hit registration on primary.
- Fixed Special beam giving the wrong damage location (this made numbers appear in weird places and made focus crystal non-usable)
- Reworked shield restoration to be based on maximum HP rather than shield.
- This is a massive nerf to transcendence, but a buff in most other cases, especially early game.
- New showcase video.

### 1.2.6
- Reduced armor while using special to 100.
- Flame charge bar now responds to screen resolution and hud scale.
- Health regen reduced to compensate for shield.
- Tickrate on special reduced from 6 to 5.
- Shield aura color now responds to skin.
- (Context)
- The shield changes were pretty major, wound up making the character a bit too strong.
- Decided that slight reductions to DPS output would be a better solution than reducing the shield.

### 1.2.5
- Reduced base health by 30.
- Gave 30 base shield.
- While regaining Flame Charge you regenerate a small portion of maximum shield per second per stack.
- This is overall a buff to survivability and will hopefully help out throughout runs but especially in the early game.
- Improvements to Blighted skin.
- Started work on elite overlays varying with skin (still in progress)
- Began process of major code restructuring under the hood.

### 1.2.4
- Fixed bug causing Special to not deal damage in multiplayer when you aren't host.
- Removed Iridescent skin and replaced with a fancy new skin. (Plan on finding ways to increase the max number from 8 in the future because there are a lot of cool effects I can add here)
- Some under the hood changes.
- Fixed typo in ability descriptions.
- New showcase video.

### 1.2.3
- Base armor reduced to 0 (Not really needed anymore)
- Armor during special reduced to 150 from 200 (Still extremely high)
- Stun grenade now scales chance and duration with proc coef (it does not in the base game)
- This was done to keep Utility from permastunning enemies with a single stun grenade.
- Re-tuned charge gain to take the class of the enemy (boss vs miniboss vs basic) and the elite tier into account.
- Generally tuned down overall charge gain to compensate for this.
- Special has a 25% larger radius.
- Utility has significantly nicer visuals now.
- Special now zooms camera in to help with piercing targets at close range.
- Ability descriptions improved.
- Character portrait.
- Icons for all skills (Primary, Utility, and Special are placeholder icons)
- Fixed weird textures in logbook display.
- Very likely some under the hood changes I am forgetting at the moment.

### 1.2.2
- Insert explitives about video here...

### 1.2.1
- Updated showcase video... Again...
- Fixed minor typo in ability description.

### 1.2.0
- Updated showcase video.
- Completely reworked special into a laser type attack that prevents movement but gives armor and deals heavy damage.
- For anyone who liked cremation, It will likely return as a variant in the future with some tweaks.
- Primary no longer scales damage with charge.
- Primary charge gain per attack doubled.
- Primary has some tweaked animations, hopefully feels more smooth.
- Fixed a bug causing small enemies to give more charge than expected on death.
- Removed the Ascendent skin and replaced it with Abyssal which is red and stuff.
- Compatibility with R2API and Bepinex updates (I hope, let me know if something conflicts)
- Super fancy beam particle effects for the laser.
- Very likely some minor things that I have forgotten... Ugh.

### 1.1.3
- You now gain 25% extra movespeed while within the range of Utility.
- Ability descriptions made even more clear.
- Item pickups now display on the character model (not all are positioned very well, but that will improve over time)
- Custom skin for the survivorpod.
- Charge UI now hides while game is paused.
- Sprint animation slightly improved (Just a temp fix until I can get all movement animations looking good)
- Fixed an animation transition bug from sprinting to standing still.

### 1.1.2
- Utility cooldown reduced by 0.00001 seconds. It is important, I promise.
- Fixed Special damage scaling once again... I'm roughly 46% certain the skill is cursed at this point.
- Special projectile now travels significantly faster.
- Special projectile now has a slightly smaller collider (hopefully will keep it from hitting the floor on fire at some angles?)
- Tuned the rate that Flame Charge is transferred from Utility to you.
- UV mapped the model (from script, please send help)
- Created a fancy custom material for the armor (It is animated!)
- Re-Scaled the character to not be like double the height of all other survivors... (They are now ~the same height as loader)
- Adjusted camera positioning and hitbox size to go along with the scaling.
- Particle effects on body fit to the shape a bit better.
- Added better visuals for aiming Utility.
- Made the in game ability descriptions more clear (I hope)
- Most likely other stuff I forgot... ugh.

### 1.1.1
- Base armor up to 10.
- Further reworked Utility.
- It now stacks Flame Charge inside it damages enemies, and as those enemies die.
- That flame charge is transferred to you over time as a buff while you are within the radius of Utility.
- In addition, damage ticks twice as often and also has a 0.05 proc coef while you are within the radius.
- Radius scales with flame charge.
- The above further reinforces the close range playstyle intended for this character.

### 1.1.0
- Fixed all known multiplayer issues (if you find more, tell me)
- Added two new buff types (one is the flame debuff on enemies, the other is a flame regeneration buff on you)
- Totally reworked Utility mechanics. Now creates one larger zone and applies stacks at an increased rate.
- The method of gaining Flame Charge from utility now operates through a buff and is overall easier early game and harder late game.
- Fixed bugs with ability damage scaling with flame charge. Bug was causing them to be much weaker than intended.
- Primary and Special totally rewritten with very similar functionality.
- New sounds for primary.
- All charge consumption is now percent based instead of flat. Abilities scale based on the amount of charge consumed.
- Special and passive both greatly buffed to have less trash names.
- Base damage reduced to 12 from 15 (because it was making equipment way too strong)
- Primary increased to 300% base damage.
- Range on primary increased to 40
- Primary cooldown increased to 2.5 seconds
- Secondary outer radius increased to 8, inner radius is now half the outer radius.
- Secondary damage reduced to 150% from 200% (The increased radius means you hit more times per enemy per wave, this is a buff against most enemies)
- Special increased to 437.5% - 1750% base damage.
- Special no longer slows at all and instead just prevents sprinting. This is overall very close to neutral, but feels better in game.
- Base armor increased to 5 (just a small nudge for survivability particularly early game)
- Ability descriptions updated...

### 1.0.3
- Even further primary cleanup
- Fixed compatibility issue with AutoItemPickup
- Reduced movespeed penalty while charging Special
- Camera position adjustments (Will include config for this setting in the future)
- Fixed a bug where flames didn't tick after spreading a certain number of times.
- Fixed a bug that prevented you from being frozen
- Validated that save file issues from skins are no longer occuring

### 1.0.2
- Further cleanup of primary behaviour
- Reduced time to charge special by 40%
- Actually updated the descriptions too this time!

### 1.0.1
- Added a Character Select display
- Tuned cooldowns and damage across the board to get damage output in line with other survivors
- Cleaned up primary behaviour to be more consistent
- Reduced radius on Special explosion, it was excessively large (may still be a bit too large, we'll see)
- In compensation for the damage changes (overall output is significantly higher than original) range on Primary and Utility are reduced.

### 1.0.0
- First release
